<template>
  <div v-if="!editing" class="gpa-task" :class="componentCSS">
    <div class="gpa-task__check">
      <rui-button :icon="task.doneAt ? 'check-square' : 'square'" text :title="$t('js.elements.last_action.finish')" @click="toggle" />
    </div>

    <div class="gpa-task__content">
      <div class="gpa-task__content__header">
        <rui-badge class="gpa-task__content__header__user" :caption="assignee.username" icon="user" />
        <div v-if="showDate" class="gpa-task__content__header__date">
          {{ $d(task.plannedFor, 'date') }}
        </div>
        <div class="gpa-task__content__header__title">
          <rui-badge v-if="task.action" v-bind="actionProps" size="small" />
          <rui-badge :caption="subjectProperties.name" :icon="subjectProperties.icon" size="small" />
          {{ task.name }}
          <rui-badge v-if="doneLateBy" :variant="doneLateBy > 0 ? 'warning': 'success'" size="small" inverse>
            <template v-if="doneLateBy > 0">{{ $t('js.task.done_late_by_days', {days: doneLateBy}) }}</template>
            <template v-else>{{ $t('js.task.done_early_by_days', {days: -doneLateBy}) }}</template>
          </rui-badge>
        </div>

        <div class="gpa-task__header__actions">
          <rui-toolbar>
            <rui-button icon="pencil" :caption="$t('generic.edit')" no-text-on-small @click="edit" />
            <rui-button icon="trash" :title="$t('generic.destroy')" variant="destructive" @click="trash" />
          </rui-toolbar>
        </div>
      </div>
      <div v-if="task.notes" class="gpa-task__content__note">
        {{ task.notes }}
      </div>
    </div>
  </div>

  <form v-else class="gpa-task gpa-task--form" @submit.prevent="update">
    <div class="gpa-task__content">
      <div>
        <rui-date-time-picker v-model="inputs.planned_for"
                              :label="$t('activerecord.attributes.task.planned_for')"
                              :time="false"
                              :input-id="`${formId}-date`"
                              :popup="true"
                              :required="true"
                              input-name="date" />
      </div>

      <div>
        <rui-date-time-picker v-model="inputs.done_at"
                              :label="$t('activerecord.attributes.task.done_at')"
                              :time="false"
                              :input-id="`${formId}-done_at`"
                              :popup="true"
                              input-name="done_at" />
      </div>

      <div>
        <rui-field :input-id="`${formId}-assignee`" :label="$t('activerecord.attributes.task.assignee')">
          <select :id="`${formId}-assignee`" v-model="inputs.assignee_id" :name="`${formId}-assignee`">
            <option v-for="teamMate in teamMates" :key="teamMate.id" :value="teamMate.user.id">{{ teamMate.user.username }}</option>
          </select>
        </rui-field>
      </div>

      <div>
        <rui-field :input-id="`${formId}-name`" :label="$t('activerecord.attributes.task.name')">
          <input :id="`${formId}-name`"
                 v-model="inputs.name"
                 type="text"
                 :name="`${formId}-name`">
        </rui-field>
      </div>

      <div class="gpa-task__content__header__title">
        <rui-field :input-id="`${formId}-notes`" :label="$t('activerecord.attributes.task.notes')">
          <textarea :id="`${formId}-notes`" v-model="inputs.notes" :name="`${formId}-notes`" />
        </rui-field>
      </div>

      <div class="gpa-task__content__header__actions">
        <rui-toolbar>
          <rui-button variant="canceling" @click="editing = false">{{ $t('generic.cancel') }}</rui-button>
          <rui-submit-button :loading="loading" />
        </rui-toolbar>
      </div>
    </div>
  </form>
</template>

<script>
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'
import RuiSubmitButton from '@experiments-labs/rise_ui/src/components/Inputs/SubmitButton/SubmitButton.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import Task from '../../../../classes/models/Task'
import Toaster from '../../../../tools/Toaster'
import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import { diffInDays } from '@experiments-labs/rise_ui/src/lib/Dates'
import { subjectProperties } from '@/vue/tools/SubjectProperties'

export default {
  name: 'GpaTask',
  components: { RuiSubmitButton, RuiField, RuiDateTimePicker, RuiToolbar, RuiBadge, RuiButton },
  props: {
    task: { required: true, type: Task },
    showDate: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      loading: false,
      // Form related data
      editing: false,
      inputs: {},
      formId: randomString(),
    }
  },
  computed: {
    doneLateBy () {
      if (!this.task.doneAt) return null

      return diffInDays(this.task.doneAt, this.task.plannedFor)
    },
    subject () { return this.task.subject },
    teamMates () { return this.$store.getters.teamMates },
    assignee () {
      if (this.task.assigneeId) {
        const teamMate = this.$store.getters.teamMateByUserId(this.task.assigneeId)
        if (teamMate) return teamMate.user
      }

      // Teammate not found or no assignee: return the map owner
      return this.$store.getters.currentMap.user
    },
    subjectProperties () {
      return subjectProperties(this.subject)
    },
    actionProps () {
      if (!this.task.action) return null
      switch (this.task.action) {
        case 'implant': return { icon: 'arrow-bend-right-down', title: this.$t('js.task.actions.implant') }
        case 'remove': return { icon: 'arrow-bend-right-up', title: this.$t('js.task.actions.remove') }
        default: return { icon: 'warning', title: this.$t('js.task.unknown_action') }
      }
    },
    componentCSS () {
      return [
        this.task.doneAt && 'gpa-task--done',
      ]
    },
  },
  methods: {
    toggle () {
      this.doUpdate({ id: this.task.id, done_at: this.task.doneAt ? null : new Date() })
    },
    update () {
      this.doUpdate(this.inputs)
    },
    doUpdate (payload) {
      const callback = () => {
        this.loading = true
        this.$store.dispatch('updateTask', payload)
          .then(() => {
            this.editing = false
          })
          .then(() => {
            this.loading = false
          })
      }

      if (this.task.doneAt && this.task.action && Object.prototype.hasOwnProperty.call(payload, 'done_at') && payload.done_at !== this.task.doneAt) {
        this.$emitBus('ask-confirmation', {
          caption: this.$t('js.task.undo_action_title'),
          message: this.$t('js.task.undo_action_notice'),
          callback,
        })
      } else { callback() }
    },
    edit () {
      this.inputs = {
        id: this.task.id,
        name: this.task.name,
        assignee_id: this.task.assigneeId,
        planned_for: this.task.plannedFor,
        done_at: this.task.doneAt,
        notes: this.task.notes,
      }
      this.editing = true
    },
    trash () {
      this.$emitBus('ask-confirmation', {
        message: this.$t('js.task.destroy_warning'),
        caption: this.$t('js.task.destroy_warning_title'),
        callback: () => {
          this.loading = true
          this.$store.dispatch('destroyTask', this.task.id)
            .then(() => {
              Toaster.success(this.$t('js.elements.last_action.destroyed_successfully'))
            })
            .then(() => {
              this.loading = false
            })
        },
      })
    },
  },
}
</script>

<style lang="scss" src="./Task.scss" />
